package jf04;

/**
 *
 * @author Lefteris Moussiades
 */
public class TwoDim {

    public static void create() {
        //double [][][] century;
        int[][] store = new int[3][3];
        for (int i = 0; i < store.length; i++) {
            for (int j = 0; j < store[i].length; j++) {
                store[i][j] = i * 100 + j;
            }
        }
        for (int[] aElement : store) {
            for (int i : aElement) {
                System.out.print(i + " ");
            }
            System.out.println();
        }
    }

    public static void create2() {
        int[][] store = new int[3][];
        store[0] = new int[]{1, 2};
        store[1] = new int[3];
        store[1][0] = 4;
        store[1][1] = 5;
        store[1][2] = 6;
        store[2] = new int[]{6, 7, 8};

        for (int i = 0; i < store.length; i++) {
            for (int j = 0; j < store[i].length; j++) {
                System.out.print(store[i][j]);
            }
            System.out.println("");
        }
    }

    public static void initByConstant() {
        String[][] store = {
            {"John", "Mike", "George"},
            {"Flora", "Mary"},
            {"Lousi", "Kathrin", "Jane"}
        };
        for (String[] aElement : store) {
            for (String name : aElement) {
                System.out.print(name + " ");
            }
            System.out.println("");
        }
    }

    public static void copy() {
        char[][] copyFrom = {
            {'d', 'e'},
            {'c', 'a', 'f', 'f', 'e', 'i', 'n'},
            {'a', 't', 'e', 'd'}
        };
        char[][] copyTo = new char[3][];
        copyTo[2] = new char[]{'l', 'i', 'k', 'e'};
        System.arraycopy(copyFrom, 1, copyTo, 0, 2);
        for (char[] aElement : copyTo) {
            for (char c : aElement) {
                System.out.print(c + " ");
            }
            System.out.println();
        }
    }

    public static void merge() {
        char[] a = {'G', 'o', 'o', 'd'};
        char[] b = {'m', 'o', 'r', 'n', 'i', 'n', 'g'};
        char[] c = new char[a.length + b.length];
        System.arraycopy(a, 0, c, 0, a.length);
        System.arraycopy(b, 0, c, a.length, b.length);
        System.out.println(new String(c));
    }

    public static void copyOfRange() {

        char[][] copyFrom = {
            {'d', 'e'},
            {'c', 'a', 'f', 'f', 'e', 'i', 'n'},
            {'a', 't', 'e', 'd'}
        };

        char[][] copyTo = java.util.Arrays.copyOfRange(copyFrom, 0, 3);

        for (char[] aElement : copyTo) {
            for (char c : aElement) {
                System.out.print(c + " ");
            }
            System.out.println();
        }
    }

    public static void copyTbl() {
        int[] source = new int[]{1, 2, 3, 4};
        int[] second = source;
        second[1] = 9;

        for (int i : source) {
            System.out.print(i + " ");
        }
        System.out.println();
    }

    public static void copyTbl2() {
        int[] source = new int[]{1, 2, 3, 4};
        int[] second = new int[4];
        //second=source;
        for (int i = 0; i < source.length && i < second.length; i++) {
            second[i] = source[i];
        }
        second[1] = 9;
        for (int i : source) {
            System.out.print(i + " ");
        }
        System.out.println();
    }

    public static void main(String[] args) {
        //create();
        //create2();
        //initByConstant();
        //copy();
        //copyOfRange();
        //copyTbl();
        //copyTbl2();
        merge();

    }
}
